diff --git a/Makefile b/Makefile
index 5ec0ab4fde..5975ab747b 100644
--- a/Makefile
+++ b/Makefile
@@ -97,7 +97,7 @@ $(BUILD_DIR)/tests/radiusd-c: raddb/test.conf ${BUILD_DIR}/bin/radiusd | build.r
 	@echo "ok"
 	@touch $@
 
-test: ${BUILD_DIR}/bin/radiusd ${BUILD_DIR}/bin/radclient tests.unit tests.xlat tests.keywords tests.auth test.sql_nas_table $(BUILD_DIR)/tests/radiusd-c | build.raddb
+test: ${BUILD_DIR}/bin/radiusd ${BUILD_DIR}/bin/radclient tests.unit tests.xlat tests.keywords tests.modules tests.auth test.sql_nas_table $(BUILD_DIR)/tests/radiusd-c | build.raddb
 	@$(MAKE) -C src/tests tests
 
 #
@@ -291,10 +291,10 @@ certs:
 ######################################################################
 BRANCH = $(shell git rev-parse --abbrev-ref HEAD)
 
-freeradius-server-$(RADIUSD_VERSION_STRING).tar.gz: .git
+freeradius-server-$(RADIUSD_VERSION_STRING).tar.gz: .git/HEAD
 	git archive --format=tar --prefix=freeradius-server-$(RADIUSD_VERSION_STRING)/ $(BRANCH) | gzip > $@
 
-freeradius-server-$(RADIUSD_VERSION_STRING).tar.bz2: .git
+freeradius-server-$(RADIUSD_VERSION_STRING).tar.bz2: .git/HEAD
 	git archive --format=tar --prefix=freeradius-server-$(RADIUSD_VERSION_STRING)/ $(BRANCH) | bzip2 > $@
 
 %.sig: %
diff --git a/VERSION b/VERSION
index de2e889324..25510162d8 100644
--- a/VERSION
+++ b/VERSION
@@ -1 +1 @@
-3.0.25
+3.0.26
diff --git a/acinclude.m4 b/acinclude.m4
index da48acc08a..a953d0e1b6 100644
--- a/acinclude.m4
+++ b/acinclude.m4
@@ -37,66 +37,6 @@ AC_DEFUN([FR_CHECK_TYPE_INCLUDE],
   fi
 ])
 
-dnl #
-dnl #  Locate the directory in which a particular file is found.
-dnl #
-dnl #  Usage: FR_LOCATE_DIR(MYSQLLIB_DIR, libmysqlclient.a)
-dnl #
-dnl #    Defines the variable MYSQLLIB_DIR to be the directory(s) in
-dnl #    which the file libmysqlclient.a is to be found.
-dnl #
-dnl #
-AC_DEFUN([FR_LOCATE_DIR],
-[
-dnl # If we have the program 'locate', then the problem of finding a
-dnl # particular file becomes MUCH easier.
-dnl #
-
-dnl #
-dnl #  No 'locate' defined, do NOT do anything.
-dnl #
-if test "x$LOCATE" != "x"; then
-  dnl #
-  dnl #  Root through a series of directories, looking for the given file.
-  dnl #
-  DIRS=
-  file=$2
-
-  for x in `${LOCATE} $file 2>/dev/null`; do
-    dnl #
-    dnl #  When asked for 'foo', locate will also find 'foo_bar', which we
-    dnl #  don't want.  We want that EXACT filename.
-    dnl #
-    dnl #  We ALSO want to be able to look for files like 'mysql/mysql.h',
-    dnl #  and properly match them, too.  So we try to strip off the last
-    dnl #  part of the filename, using the name of the file we're looking
-    dnl #  for.  If we CANNOT strip it off, then the name will be unchanged.
-    dnl #
-    base=`echo $x | sed "s%/${file}%%"`
-    if test "x$x" = "x$base"; then
-      continue;
-    fi
-
-    dir=`${DIRNAME} $x 2>/dev/null`
-    dnl #
-    dnl #  Exclude a number of directories.
-    dnl #
-    exclude=`echo ${dir} | ${GREP} /home`
-    if test "x$exclude" != "x"; then
-      continue
-    fi
-
-    dnl #
-    dnl #  OK, we have an exact match.  Let's be sure that we only find ONE
-    dnl #  matching directory.
-    dnl #
-    already=`echo \$$1 ${DIRS} | ${GREP} ${dir}`
-    if test "x$already" = "x"; then
-      DIRS="$DIRS $dir"
-    fi
-  done
-fi
-
 dnl #
 dnl #  And remember the directory in which we found the file.
 dnl #
@@ -175,10 +115,7 @@ dnl #
 dnl #  Try to guess possible locations.
 dnl #
 if test "x$smart_lib" = "x"; then
-  FR_LOCATE_DIR(smart_lib_dir,[lib$1${libltdl_cv_shlibext}])
-  FR_LOCATE_DIR(smart_lib_dir,[lib$1.a])
-
-  for try in $smart_lib_dir /usr/local/lib /opt/lib; do
+  for try in /usr/local/lib /opt/lib; do
     AC_MSG_CHECKING([for $2 in -l$1 in $try])
     LIBS="-l$1 $old_LIBS"
     CPPFLAGS="-L$try -Wl,-rpath,$try $old_CPPFLAGS"
@@ -306,11 +243,6 @@ dnl #  Try to guess possible locations.
 dnl #
 if test "x$smart_include" = "x"; then
 
-  for prefix in $smart_prefix; do
-    FR_LOCATE_DIR(_smart_include_dir,"${_prefix}/${1}")
-  done
-  FR_LOCATE_DIR(_smart_include_dir, $1)
-
   for try in $_smart_include_dir; do
     AC_MSG_CHECKING([for $1 in $try])
     CPPFLAGS="-isystem $try $old_CPPFLAGS"
diff --git a/configure.ac b/configure.ac
index ce4d9b0ae5..e5b2ea9b2f 100644
--- a/configure.ac
+++ b/configure.ac
@@ -822,7 +822,6 @@ AM_MISSING_PROG(ACLOCAL, aclocal, $missing_dir)
 AM_MISSING_PROG(AUTOCONF, autoconf, $missing_dir)
 AM_MISSING_PROG(AUTOHEADER, autoheader, $missing_dir)
 
-AC_PATH_PROG(LOCATE,locate)
 AC_PATH_PROG(DIRNAME,dirname)
 AC_PATH_PROG(GREP,grep)
 
diff --git a/doc/ChangeLog b/doc/ChangeLog
index 325a8f36bd..2669081158 100644
--- a/doc/ChangeLog
+++ b/doc/ChangeLog
@@ -1,3 +1,42 @@
+FreeRADIUS 3.0.26 Thu 07 Oct 2021 12:00:00 EDT urgency=low
+	Feature improvements
+	* Add support for OpenSSL3
+	* Add dictionary.mellanox
+	* Update dictionary.aruba, dictionary.roaringpenguin
+	* Removed haproxy support.  It's new and experimental,
+	  and belongs in the v3.2 release, where it will be
+	  fully supported.
+	* Support PEAP and TTLS with TLS 1.3.  This has been
+	  tested with wpa_supplicant and Windows 11.
+	* Add %{concat:foo[*] ;}, which concatenates a set
+	  of attributes, separated by a character.
+	* Added sample configuration for using Google LDAP.
+	  See sites-available/google-ldap-auth, and
+	  mods-available/google_ldap, and mods-available/cache_auth.
+	* Add Dockerfiles for Rocky8.
+	* Add raduat script to the freeradius-utils package.
+	* Add Debian freeradius-freetds package.
+	* Add client short name to "dropping packet" message,
+
+	Bug fixes
+	* Ensure PBKDF2 always uses at least one iteration
+	* Actually use the certificate in "realm_dir" hinted at by SNI.
+	* Removed the use of "locate" during the "configure" phase.
+	  Fixes #4318
+	* Fix for showing incomplete home server list after deleting a
+	  home server via radmin.
+	* Call closedir() when reading certificates from a directory.
+	  Found by Antonio Torres.  Fixes #4378.
+	* If we read more than 16K of data in RadSec, then read it all.
+	  Fixes #4388, patch from Aren Sandersen.
+	* Fix information leak in compute_password_element() function
+	  of EAP-PWD.  Found by Mohamed Sabt.
+	* Fix crash in EAP-SIM when unknown attributes are sent.
+	* Update linelog, etc. to allow the use of /dev/stdout
+	* Fix crash in race condition when 500+ sockets are open.
+	* Remove sample "cache_eap" module.  It does not work, and
+	  offers no benefit.
+
 FreeRADIUS 3.0.25 Thu 07 Oct 2021 12:00:00 EDT urgency=medium
 	Feature improvements
 	* Better debug output when proxying is disabled
@@ -38,6 +77,8 @@ FreeRADIUS 3.0.24 Wed 29 Sep 2021 12:00:00 EDT urgency=medium
 	* The Simultaneous-Use code is now IPv6 aware, and can deal with
 	  NAS-IPv6-Address.
 	* Add dictionary.cambium
+	* Add new %{lasttime:...} allowing calculation of a number of
+	  hours/days/weeks/years in the past.
 
 	Bug fixes
 	* Fix crash in trustrouter module (#4115). Patch from Alejandro Perez
diff --git a/doc/modules/rlm_eap b/doc/modules/rlm_eap
index 122d14f0d4..4f903af5bc 100644
--- a/doc/modules/rlm_eap
+++ b/doc/modules/rlm_eap
@@ -156,20 +156,9 @@ EAP SIM server
 
 EAP CLIENTS
 
-  1. XSupplicant - freeradius (EAP/TLS) notes may be found at:
+  1.  eapol_test, from wpa_supplicant.
 
-   http://www.eax.com/802/
-   or http://www.missl.cs.umd.edu/wireless/eaptls/
-
-   XSupplicant is hosted by:
-
-   http://www.open1x.org/
-
-  2. XP - freeradius (EAP/TLS) notes may be found at:
-
-   http://www.denobula.com/EAPTLS.pdf
-
-  3. Freeradius has an "radeapclient" that can do EAP-MD5 (passwords),
+  2. Freeradius has an "radeapclient" that can do EAP-MD5 (passwords),
      as well as EAP-SIM. It is in modules/rlm_eap/radeapclient.
 
 TESTING
diff --git a/raddb/all.mk b/raddb/all.mk
index 3a4b3ea5ac..a7f4f14b3f 100644
--- a/raddb/all.mk
+++ b/raddb/all.mk
@@ -7,7 +7,7 @@ LOCAL_FILES :=		clients.conf dictionary templates.conf experimental.conf \
 DEFAULT_SITES :=	default inner-tunnel
 LOCAL_SITES :=		$(addprefix raddb/sites-enabled/,$(DEFAULT_SITES))
 
-DEFAULT_MODULES :=	always attr_filter cache_eap chap date \
+DEFAULT_MODULES :=	always attr_filter chap date \
 			detail detail.log digest dynamic_clients eap \
 			echo exec expiration expr files linelog logintime \
 			mschap ntlm_auth pap passwd preprocess radutmp realm \
diff --git a/raddb/mods-available/cache_auth b/raddb/mods-available/cache_auth
new file mode 100644
index 0000000000..7485f36d9c
--- /dev/null
+++ b/raddb/mods-available/cache_auth
@@ -0,0 +1,116 @@
+# -*- text -*-
+#
+#  $Id$
+
+#  This file contains a collection of cache module configurations
+#  which have been designed to be used to cache accepts, rejects, and
+#  LDAP User DNs.  The main use of these modules is Google Secure
+#  LDAP.
+#
+#  In scenarios where there is repeated authentication requests for the same
+#  user within a short time frame (e.g. 802.1x wifi), these modules can help to
+#  compensate for slow responses from poor LDAP servers (i.e. Google).
+#
+#  See also mods-available/ldap_google, and sites-available/google-ldap-auth.
+#
+#  The configurations in this file can be used for non-Google LDAP
+#  servers, too.
+#
+
+
+#
+#  This instance of the cache module caches successful
+#  authentications.
+#
+#  The TTL controls how often the authentication will be cached.  
+#
+#  In addition, if group membership is used as part of the policy, the
+#  &control:LDAP-Group attribute should be added to the "update: section here.
+#
+#  If a user's authentication is found in the cache, then any data
+#  which is normally retrieved from LDAP for local policies must also
+#  be stored in the cache via the "update" section.
+#
+cache cache_auth_accept {
+	driver = "rlm_cache_rbtree"
+	key = "%{md5:%{%{Stripped-User-Name}:-%{User-Name}}%{User-Password}}"
+	ttl = 7200
+	update {
+		#	
+		#  We need to cache something, so we just cache
+		#  a random attribute.  This attribute is not used
+		#  for anything else, just as a "place-holder" to
+		#  contain a cache entry.
+		#
+		#  If you add other attributes to this update section, then
+		#  this attribute can be deleted.
+		#
+		&control:User-Category = "success"
+	}
+}
+
+
+#
+#  This instance of the cache module caches failed authentications.
+#
+#  In many cases, rejected users will repeatedly try to authenticate.
+#  These repeated authentication attempts can cause significant load
+#  on the system.  By caching the reject, we can avoid hitting the database.
+#
+#  We index the cache by a hash of the client's MAC and the user name
+#  and password.  If a user corrects their user name or password, then
+#  that authentication attempt won't hit the cache, and their
+#  credentials will be immediately checked against the database.
+#
+#  The TTL controls how long a combination of device / user and
+#  password wil be rejected without looking at the database.  Once the
+#  cache entry expires, the server will delete the cache entry, and
+#  contact the database.
+#
+cache cache_auth_reject {
+        driver = "rlm_cache_rbtree"
+        key = "%{md5:%{Calling-Station-Id}%{Stripped-User-Name}%{User-Password}}"
+        ttl = 3600
+        update {
+		#	
+		#  We need to cache something, so we just cache
+		#  a random attribute.  This attribute is not used
+		#  for anything else, just as a "place-holder" to
+		#  contain a cache entry.
+		#
+		&control:User-Category = "failure"
+        }
+}
+
+
+#
+#  An instance of the cache module which caches the LDAP user DN.
+#
+#  If LDAP authentication is being used for a simple auth / reject without
+#  any need to retrieve other attributes (e.g. group membership), each LDAP
+#  bind authentication is three steps
+#
+#    - bind as admin user
+#    - lookup user's DN
+#    - bind as user using retrieved DN
+#
+#  By caching the DN after the first LDAP querry, the first two steps
+#  are skipped on subsequent authentications.
+#
+#  If an alternative attribute name is being used for the user DN, you
+#  should change the update section here appropriately.  But that is
+#  likely rare.
+#
+#  In scenarios where DNs may change, consideration should be given as
+#  to whether use of this cache may create issues.  i.e. if the cache
+#  doesn't help, then don't use it.
+#
+cache cache_ldap_user_dn {
+	driver = "rlm_cache_rbtree"
+	key = "%{Stripped-User-Name}"
+	ttl = 86400
+	update {
+		&control:LDAP-UserDN = &control:LDAP-UserDN
+	}
+}
+
diff --git a/raddb/mods-available/eap b/raddb/mods-available/eap
index 61be516b1a..7eba82c7f4 100644
--- a/raddb/mods-available/eap
+++ b/raddb/mods-available/eap
@@ -270,12 +270,16 @@ eap {
 		#
 	#	psk_query = "%{sql:select hex(key) from psk_keys where keyid = '%{TLS-PSK-Identity}'}"
 
-		#  For DH cipher suites to work, you have to
-		#  run OpenSSL to create the DH file first:
+		#  For DH cipher suites to work in OpenSSL < 1.1.0,
+		#  you have to run OpenSSL to create the DH file
+		#  first:
 		#
 		#    openssl dhparam -out certs/dh 2048
 		#
-		dh_file = ${certdir}/dh
+		#  For OpenSSL >= 1.1.0, just leave this commented
+		#  out, and OpenSSL will do the right thing.
+		#
+	#	dh_file = ${certdir}/dh
 
 		#  If your system doesn't have /dev/urandom,
 		#  you will need to create this file, and
@@ -453,6 +457,12 @@ eap {
 		#  In order to enable TLS 1.0 and TLS 1.1, you may
 		#  also need to update cipher_list below to:
 		#
+		#   * OpenSSL >= 3.x
+		#
+		#	cipher_list = "DEFAULT@SECLEVEL=0"
+		#
+		#   * OpenSSL < 3.x
+		#
 		#	cipher_list = "DEFAULT@SECLEVEL=1"
 		#
 		#  The values must be in quotes.
@@ -493,7 +503,7 @@ eap {
 		#
 		#	openssl ecparam -list_curves
 		#
-		ecdh_curve = "prime256v1"
+		ecdh_curve = ""
 
 		#  Session resumption / fast reauthentication
 		#  cache.
@@ -725,6 +735,20 @@ eap {
 			#
 		#	softfail = no
 		}
+
+		#
+		#  The server can present different certificates based
+		#  on the realm presented in EAP.  See
+		#  raddb/certs/realms/README.md for examples of how to
+		#  configure this.
+		#
+		#  Note that the default is to use the same set of
+		#  realm certificates for both EAP and RadSec!  If
+		#  this is not what you want, you should use different
+		#  subdirectories or each, e.g. ${certdir}/realms/radsec/,
+		#  and ${certdir}/realms/eap/
+		#
+	#	realm_dir = ${certdir}/realms/
 	}
 
 
diff --git a/raddb/mods-available/expr b/raddb/mods-available/expr
index 43dbea35e4..4cecfca478 100644
--- a/raddb/mods-available/expr
+++ b/raddb/mods-available/expr
@@ -130,12 +130,18 @@
 #  nexttime	calculate number of seconds until next n hour(s), day(s), week(s), year(s)
 #		if it were 16:18, %{nexttime:1h} would expand to 2520
 #
+#  lasttime	calculate number of seconds until last n hour(s), day(s), week(s), year(s)
+#		if it were 16:18, %{lasttime:1h} would expand to 4680
+#
 #  lpad		left-pad a string
 #		if User-Name is "foo": "%{lpad:&User-Name 6 x}" == "xxxfoo"
 #
 #  rpad		right-pad a string
 #		if User-Name is "foo": "%{rpad:&User-Name 5 -}" == "foo--"
 #
+#  concat 	concatenate a set of attributes, separated by a character.
+#		"%{concat:foo[*] ;}"
+#
 
 expr {
 	#
diff --git a/raddb/mods-available/ldap_google b/raddb/mods-available/ldap_google
new file mode 100644
index 0000000000..03c98d38ff
--- /dev/null
+++ b/raddb/mods-available/ldap_google
@@ -0,0 +1,262 @@
+# -*- text -*-
+#
+#  $Id$
+
+#
+#  This file contains an instance of the ldap module which has been
+#  configured for the G Suite / Google Workspace Secure LDAP server.
+#  There are a few steps which still need to be taken, but they are
+#  documented clearly below.
+#
+#  In order to use the Google LDAP server, a client must first be
+#  created. See Google's documentation for doing this:
+#
+#  https://support.google.com/a/answer/9048434?hl=en&ref_topic=9173976
+#
+#  Google LDAP requires that any system connecting to it use a client
+#  certificate.  However, FreeRADIUS also requires a username and
+#  password in the "ldap" module configuration.  Therere before
+#  downloading the client certificate from Google, you should choose
+#  the option to generate access credentials in order to obtain a
+#  username and password.  That username and password should be used
+#  below.
+#
+#  Ensure the Goolge client configuration which is used for FreeRADIUS
+#  has sufficient permissions to read user information, and, if group
+#  membership is part of the FreeRADIUS policy, ensure that the client
+#  can read group information.  This configuration is done on Google's
+#  systems.  Please see the Google documentation for more information.
+#
+#  NOTE: The Google LDAP database does NOT return user passwords in
+#  the search results!
+#
+#  Therefore, if Google LDAP is being used for authentication, it will
+#  ONLY work when using "LDAP bind as user".  The authentication
+#  method used there MUST also provide the user password in plain
+#  text.  This limits the use of Google LDAP to PAP, and TTLS+PAP.
+#  Anything else simply will not work, and nothing you do will ever
+#  make it work.
+#
+#  The Google LDAP service has been observed to have poor
+#  performance compared to a dedicated / local LDAP server like
+#  OpenLDAP. In order to improve performance, we simply bypass it
+#  completely by caching things associated with accept and reject.
+#  See mods-available/cache_auth for the cache configuration, and
+#  sites-available/google-ldap-auth for a sample virtual server which
+#  uses this module, and the cache.
+#
+#  In addition, if you are using Google LDAP service as part of WiFi
+#  authentication (remember, only TTLS+PAP will work!), then we also
+#  recommend enabling the "cache" configuration in mods-available/eap.
+#  That cache is a separate one from mods-available/cache_auth, and
+#  both caches can be used at the same time.
+#
+#
+#  The comments in this file are specific to using the Google Secure
+#  LDAP service.  For more general LDAP module configuration, see the
+#  mods-available/ldap.
+#
+ldap ldap_google {
+	#  The standard Google LDAP server URL
+	server = 'ldaps://ldap.google.com:636/'
+
+	#  Google LDAP client username and password as generated during
+	#  client creation.
+#	identity = 'myuser'
+#	password = 'mypass'
+
+	#  Base dn for your organisation.
+	base_dn = 'dc=example,dc=org'
+
+	#
+	#  The default Google LDAP schema can be seen here
+	#
+	# 	https://support.google.com/a/answer/9188164
+	#
+	#  Custom attributes can be added to user profiles, and those
+	#  custom attributes can then be accessed in the LDAP
+	#  directory:
+	#
+	#	https://support.google.com/a/answer/6208725
+	#
+	#  You can run the 'ldapsearch' command line tool using the
+	#  parameters from this module's configuration.
+	#
+	#    LDAPTLS_REQCERT=ALLOW \
+	#    LDAPTLS_CERT="<Google certificate file>" \
+	#    LDAPTLS_KEY="<Google key file>" \
+	#    ldapsearch -H ${server}  -b '${base_dn}' '(uid=user)'
+	#
+	#  That command will return the LDAP information for 'user'.
+	#
+	#  Group membership can be queried by using the above "ldapsearch" string,
+	#  and adding "memberof" qualifiers.
+	#
+
+#	valuepair_attribute = 'radiusAttribute'
+
+	update {
+#		reply:Reply-Message		:= 'radiusReplyMessage'
+#		reply:Tunnel-Type		:= 'radiusTunnelType'
+#		reply:Tunnel-Medium-Type	:= 'radiusTunnelMediumType'
+#		reply:Tunnel-Private-Group-ID	:= 'radiusTunnelPrivategroupId'
+
+		control:			+= 'radiusControlAttribute'
+		request:			+= 'radiusRequestAttribute'
+		reply:				+= 'radiusReplyAttribute'
+	}
+
+	#
+	#  In order to use LDAP "bind as user" authentication, you
+	#  should add following "if" statement to the authorize {}
+	#  section of the virtual server, after the "ldap" module.
+	#  For example:
+	#
+	#    ...
+	#    ldap_google
+	#    if ((ok || updated) && User-Password && !control:Auth-Type) {
+	#        update {
+	#            &control:Auth-Type := ldap
+	#        }
+	#    }
+	#    ...
+	#
+	#  You will also need to uncomment the "Auth-Type LDAP" block in the
+	#  "authenticate" section.
+	#
+	#  Note that these configuration steps have already been done
+	#  in the sample virtual server, in
+	#  sites-available/google-ldap-auth.
+	#
+
+	#
+	#  If you change this, you will also need to update the
+	#  "cache_ldap_user_dn" module in mods-available/cache_auth.
+	#
+	user_dn = "LDAP-UserDn"
+
+	#
+	#  User object identification.
+	#
+	user {
+		#  The typical Google LDAP configuration has users under "ou=Users..."
+		base_dn = "ou=Users,${..base_dn}"
+
+		filter = "(uid=%{%{Stripped-User-Name}:-%{User-Name}})"
+
+		scope = 'sub'
+
+#		sort_by = '-uid'
+
+#		access_attribute = 'dialupAccess'
+
+#		access_positive = yes
+	}
+
+	#
+	#  User membership checking.
+	#
+	group {
+		#  The typical Google LDAP configuration has groups under "ou=Groups..."
+		base_dn = "ou=Groups,${..base_dn}"
+
+		filter = '(objectClass=posixGroup)'
+
+		scope = 'sub'
+
+		name_attribute = cn
+
+		#
+		#  Google Secure LDAP supports the "memberOf"
+		#  attribute, which is more efficient than using this
+		#  filter.
+		#
+		#  You should also check the permissions of the client
+		#  in Google's systems to ensure that it is allowed to
+		#  read group information.
+		#
+#		membership_filter = "(|(member=%{control:${..user_dn}})(memberUid=%{%{Stripped-User-Name}:-%{User-Name}}))"
+
+		membership_attribute = 'memberOf'
+
+		#
+		#  If the "memberOf" attribute is used for retrieving group membership,
+		#  then you should also use "cacheable_dn", in orser to cache the group details.
+		#  "memberOf" is a list of fully quallified group DNs which the user belongs to,
+		#  so using the DN for the cache avoids further lookups to retrieve group names.
+		#
+#		cacheable_name = 'no'
+#		cacheable_dn = 'no'
+
+#		cache_attribute = 'LDAP-Cached-Membership'
+
+#		allow_dangling_group_ref = 'no'
+	}
+
+	options {
+#		dereference = 'always'
+
+		#  Google Secure LDAP does not appear to do referrals, so we might as well
+		#  turn this off.
+		chase_referrals = no
+#		rebind = yes
+
+		#  Some reasonable defaults for use with Google Secure LDAP
+		#
+		#  See mods-available/ldap for a complete description
+		#  of what these configuration options mean.
+		#
+		res_timeout = 10
+		srv_timelimit = 3
+		net_timeout = 3
+		idle = 60
+		probes = 3
+		interval = 3
+
+		ldap_debug = 0x0000
+	}
+
+	tls {
+
+		#
+		#  The certificate and key which were downloaded from the Google
+		#  client tools are configured here.
+		#
+		#  By default ${certdir} is raddb/certs/.  You can
+		#  please these files anywhere you want. The only
+		#  requirement is that they are readable by
+		#  FreeRADIUS, and NOT readable by anyone else on the
+		#  system!
+		#
+#		certificate_file = ${certdir}/google/certificate.crt
+#		private_key_file = ${certdir}/google/key.key
+#		random_file = /dev/urandom
+
+		#
+		#  Google Secure LDAP uses a self signed certificate
+		#  so this configuration needs to be set to 'allow'
+		#
+		require_cert	= 'allow'
+
+		#
+		#  We recommend not using TLS 1.0 or 1.1.
+		#
+#		tls_min_version = "1.2"
+	}
+
+	#
+	#  See mods-available/ldap for documentation on the "pool"
+	#  section and its configuration items.
+	#
+	pool {
+		start = ${thread[pool].start_servers}
+		min = ${thread[pool].min_spare_servers}
+		max = ${thread[pool].max_servers}
+		spare = ${thread[pool].max_spare_servers}
+
+		uses = 0
+		retry_delay = 30
+		lifetime = 0
+		idle_timeout = 60
+	}
+}
diff --git a/raddb/mods-available/linelog b/raddb/mods-available/linelog
index dc2a8195b3..4357b747d6 100644
--- a/raddb/mods-available/linelog
+++ b/raddb/mods-available/linelog
@@ -15,6 +15,9 @@ linelog {
 	#
 	#  If the filename is "syslog", then the log messages will
 	#  go to syslog.
+	#
+	#  The output can be directed to stdout by using /dev/stdout
+	#
 	filename = ${logdir}/linelog
 
 	#
diff --git a/raddb/mods-config/sql/counter/mysql/dailycounter.conf b/raddb/mods-config/sql/counter/mysql/dailycounter.conf
index dbfb097cd7..67c7f359de 100644
--- a/raddb/mods-config/sql/counter/mysql/dailycounter.conf
+++ b/raddb/mods-config/sql/counter/mysql/dailycounter.conf
@@ -31,3 +31,16 @@ query = "\
 #	FROM radacct \
 #	WHERE username = '%{${key}}' \
 #	AND acctstarttime BETWEEN FROM_UNIXTIME('%%b') AND FROM_UNIXTIME('%%e')"
+
+#
+#  This query allows retrieving the entries based on a
+#  period that resets on a particular day of the month.
+#
+#reset_day = 21
+#query = "\
+#	SELECT SUM(acctsessiontime) FROM radacct WHERE username = '%{${key}}' AND \
+#		IF (DAY(CURDATE()) >= ${reset_day}, \
+#			acctstarttime > DATE(DATE_FORMAT(NOW(), '%Y-%m-${reset_day}')), \
+#			acctstarttime > DATE(DATE_FORMAT(NOW() - INTERVAL 1 MONTH, '%Y-%m-${reset_day}')) \
+#		)"
+#
diff --git a/raddb/mods-config/sql/main/mssql/queries.conf b/raddb/mods-config/sql/main/mssql/queries.conf
index 3001b73ac9..6c39e6de28 100644
--- a/raddb/mods-config/sql/main/mssql/queries.conf
+++ b/raddb/mods-config/sql/main/mssql/queries.conf
@@ -209,7 +209,7 @@ accounting {
 					FramedIPv6Prefix, \
 					FramedInterfaceId, \
 					DelegatedIPv6Prefix \
-					${..class.column_name}) \
+					${....class.column_name}) \
 			VALUES(\
 				'%{Acct-Session-Id}', \
 				'%{Acct-Unique-Session-Id}', \
@@ -279,7 +279,7 @@ accounting {
 					AcctStartDelay, \
 					AcctStopDelay, \
 					XAscendSessionSvrKey \
-					${..class.column_name}) \
+					${....class.column_name}) \
 				VALUES(\
 					'%{Acct-Session-Id}', \
 					'%{Acct-Unique-Session-Id}', \
@@ -387,7 +387,7 @@ accounting {
 					DelegatedIPv6Prefix, \
 					AcctStartDelay, \
 					XAscendSessionSvrKey \
-					${..class.column_name}) \
+					${....class.column_name}) \
 				VALUES(\
 					'%{Acct-Session-Id}', \
 					'%{Acct-Unique-Session-Id}', \
@@ -488,7 +488,7 @@ accounting {
 					DelegatedIPv6Prefix, \
 					AcctStartDelay, \
 					AcctStopDelay \
-					${..class.column_name}) \
+					${....class.column_name}) \
 				VALUES(\
 					'%{Acct-Session-Id}', \
 					'%{Acct-Unique-Session-Id}', \
diff --git a/raddb/mods-config/sql/main/oracle/queries.conf b/raddb/mods-config/sql/main/oracle/queries.conf
index 77eb618ac3..e3dd7670f9 100644
--- a/raddb/mods-config/sql/main/oracle/queries.conf
+++ b/raddb/mods-config/sql/main/oracle/queries.conf
@@ -356,7 +356,7 @@ accounting {
 					AcctStartDelay,	\
 					AcctStopDelay, \
 					XAscendSessionSvrKey \
-					${..class.column_name}) \
+					${....class.column_name}) \
 				VALUES(\
 					'', \
 					'%{Acct-Session-Id}', \
@@ -474,7 +474,7 @@ accounting {
 					DelegatedIPv6Prefix, \
 					AcctStartDelay,	\
 					XAscendSessionSvrKey \
-					${..class.column_name}) \
+					${....class.column_name}) \
 				VALUES(\
 					'', \
 					'%{Acct-Session-Id}', \
@@ -587,7 +587,7 @@ accounting {
 					DelegatedIPv6Prefix, \
 					AcctStartDelay,	\
 					AcctStopDelay \
-					${..class.column_name}) \
+					${....class.column_name}) \
 				VALUES(\
 					'', \
 					'%{Acct-Session-Id}', \
diff --git a/raddb/policy.d/accounting b/raddb/policy.d/accounting
index 7672e1bf1e..7c52637d11 100644
--- a/raddb/policy.d/accounting
+++ b/raddb/policy.d/accounting
@@ -54,6 +54,10 @@ acct_unique {
 			&Acct-Unique-Session-Id := "%{md5:%{User-Name},%{Acct-Session-ID},%{%{NAS-IPv6-Address}:-%{NAS-IP-Address}},%{NAS-Identifier},%{NAS-Port-ID},%{NAS-Port}}"
 		 }
 	}
+
+	update request {
+		&Tmp-String-9 !* ANY
+	}
 }
 
 #
diff --git a/raddb/policy.d/eap b/raddb/policy.d/eap
index 17cf87331c..c8dac22f3d 100644
--- a/raddb/policy.d/eap
+++ b/raddb/policy.d/eap
@@ -1,46 +1,3 @@
-#
-#	Response caching to handle proxy failovers
-#
-Xeap.authorize {
-	cache_eap
-	if (ok) {
-		#
-		#	Expire previous cache entry
-		#
-		if (&control:State) {
-			update control {
-				&Cache-TTL := 0
-			}
-			cache_eap
-
-			update control {
-				&State !* ANY
-			}
-		}
-
-		handled
-	}
-	else {
-		eap.authorize
-	}
-}
-
-#
-#	Populate cache with responses from the EAP module
-#
-Xeap.authenticate {
-	eap {
-		handled = 1
-	}
-	if (handled) {
-		cache_eap.authorize
-
-		handled
-	}
-
-	cache_eap.authorize
-}
-
 #
 #       Forbid all EAP types.  Enable this by putting "forbid_eap"
 #       into the "authorize" section.
diff --git a/raddb/proxy.conf b/raddb/proxy.conf
index ac90a27352..f8d28e3518 100644
--- a/raddb/proxy.conf
+++ b/raddb/proxy.conf
@@ -729,6 +729,9 @@ realm example.com {
 	#
 	#  If you do not want this to happen, uncomment "nostrip" below.
 	#
+	#  Note that if the system is doing EAP, you MUST set the "nostrip"
+	#  option for realms used in EAP.  Otherwise EAP will fail.
+	#
 	# nostrip
 
 	#  There are no more configuration entries for a realm.
diff --git a/raddb/radiusd.conf.in b/raddb/radiusd.conf.in
index 70c0c32547..69f0367b38 100644
--- a/raddb/radiusd.conf.in
+++ b/raddb/radiusd.conf.in
@@ -151,13 +151,21 @@ pidfile = ${run_dir}/${name}.pid
 #
 #  correct_escapes: use correct backslash escaping
 #
+#  This setting is for compatibility with 3.0.4 and earlier.  If
+#  you're running a copy of the configuration from 3.0.4, you can
+#  change this setting to "no" in order to run a new binary using the
+#  old configuration files.
+#
+#  If you've created the configuration after 2014, this should be set
+#  to "true", and you can ignore it.
+#
 #  Prior to version 3.0.5, the handling of backslashes was a little
 #  awkward, i.e. "wrong".  In some cases, to get one backslash into
 #  a regex, you had to put 4 in the config files.
 #
-#  Version 3.0.5 fixes that.  However, for backwards compatibility,
+#  Version 3.0.5 fixed that.  However, for backwards compatibility,
 #  the new method of escaping is DISABLED BY DEFAULT.  This means
-#  that upgrading to 3.0.5 won't break your configuration.
+#  that upgrading from a 3.0.4 or below won't break your configuration.
 #
 #  If you don't have double backslashes (i.e. \\) in your configuration,
 #  this won't matter to you.  If you do have them, fix that to use only
